package cn.efunbox.audio.aop;

import cn.efunbox.audio.consts.Consts;
import cn.efunbox.audio.service.AdminService;
import cn.efunbox.audio.utils.ApiCode;
import cn.efunbox.audio.utils.HttpUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.data.redis.core.ValueOperations;
import org.springframework.web.servlet.HandlerInterceptor;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 管理员验证拦截器
 * Created by yao on 17-9-29.
 */

public class AdminInterceptor implements HandlerInterceptor {

    @Autowired
    AdminService adminService;
    @Autowired
    StringRedisTemplate stringRedisTemplate;

    @Override
    public boolean preHandle(HttpServletRequest request,
                             HttpServletResponse response, Object handler) throws Exception {
        String id = request.getParameter("id");
        String token = request.getParameter("token");
        if(id==null || token==null){
            HttpUtil.responseApiCode(request, response, ApiCode.PARAMETER_ERROR);
            return false;
        }
        ValueOperations valueOperations = stringRedisTemplate.opsForValue();
        String tokenSes = valueOperations.get(Consts.REDIS_ADMIN+id)==null?
                "":valueOperations.get(Consts.REDIS_ADMIN+id).toString();
        if(false == tokenSes.equalsIgnoreCase(token)){
            HttpUtil.responseApiCode(request, response, ApiCode.INVALID_TOKEN);
            return false;
        }

        return true;
    }

    @Override
    public void postHandle(HttpServletRequest request,
                           HttpServletResponse response, Object handler,
                           ModelAndView modelAndView) throws Exception {
    }

    @Override
    public void afterCompletion(HttpServletRequest request,
                                HttpServletResponse response, Object handler, Exception ex)
            throws Exception {

    }

}
