package cn.efunbox.audio.controller;

import cn.efunbox.audio.entity.Grouping;
import cn.efunbox.audio.service.GroupingService;
import cn.efunbox.audio.utils.ApiCode;
import cn.efunbox.audio.utils.HttpUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * Created by yao on 17-9-26.
 */
@RestController
@Slf4j
@RequestMapping(value = "/grouping")
public class GroupingController {

    @Autowired
    GroupingService groupingService;

    @RequestMapping(value = "/search" ,method = RequestMethod.POST)
    public void Search(HttpServletRequest request, HttpServletResponse response){
        String name = request.getParameter("name");
        String id = request.getParameter("gid");
        String idFather = request.getParameter("idFather");
        if(name==null && id==null && idFather==null){
            HttpUtil.responseApiCode(request, response, ApiCode.PARAMETER_ERROR);
            return;
        }
        List<Grouping> list = null;
        if(id!=null && id.length()>0)
            list = groupingService.SearchById(Long.valueOf(id));
        else if(name!=null && name.length()>0)
            list = groupingService.SearchByName(name);
        else if(idFather!=null && idFather.length()>0)
            list = groupingService.SearchByIdFather(Long.valueOf(idFather));

        if(list==null || list.size()<1){
            HttpUtil.responseApiCode(request, response, ApiCode.NOT_FOUND);
            return;
        }

        HttpUtil.responseOkData(request, response, list);
        return;
    }

    @RequestMapping(value = "/insert", method = RequestMethod.POST)
    public void Insert(HttpServletRequest request, HttpServletResponse response){
        String name = request.getParameter("name");
        String idFather = request.getParameter("idFather");
        if(name==null){
            HttpUtil.responseApiCode(request, response, ApiCode.PARAMETER_ERROR);
            return;
        }
        if(idFather==null || idFather.length()==0)
            idFather = "0";

        List<Grouping> list = groupingService.SearchByName(name);
        if(list!=null && list.size()>0){
            HttpUtil.responseApiCode(request, response, ApiCode.RECORD_EXIST);
            return;
        }
        Grouping grouping = new Grouping();
        grouping.setName(name);
        grouping.setIdFather(Long.valueOf(idFather));
        grouping = groupingService.Insert(grouping);
        HttpUtil.responseOutWithJson(request, response, grouping);
        return;
    }

}
