package cn.efunbox.audio.entity;


import cn.efunbox.audio.consts.Status;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

/**
 * 资源分组
 * Created by yao on 17-9-26.
 */


@Data
@ToString
@Entity
@DynamicInsert
@DynamicUpdate
public class Grouping implements Serializable, Cloneable {

    @Id
    @GeneratedValue
    private Long id;

    //上级组编号
    @Column
    private Long idFather = 0L;

    //组名称，如唐诗、宋词
    @Column
    private String name;

    @Column
    private int status= Status.ONLINE.getCode();

    @Column
    @Temporal(TemporalType.TIMESTAMP)
    private Date created;

    public Object clone() throws CloneNotSupportedException {
        return super.clone();
    }


}
